From 3a640aa0f5555ccc327588ef7bb8d4ba5941442d Mon Sep 17 00:00:00 2001
Message-Id: <3a640aa0f5555ccc327588ef7bb8d4ba5941442d.1708458402.git.Hong-Chih.Hsueh@amd.com>
From: Neo Hsueh <Hong-Chih.Hsueh@amd.com>
Date: Tue, 6 Feb 2024 16:12:34 -0600
Subject: [PATCH] MdeModulePkg/PciBusDxe: plug device hierarchy leak upon
 bridge hot-unplug

A USB4 or TBT bridge can be plugged or unplugged on USB4 port. The actions require PciHotPlugRequestNotify to add a root bridge or remove a root bridge completely.
In the plug-unplug-plug scenerio, PciHotPlugRequestNotify will return with no-action on second plug because bridge tree shows configured.
Destroy Pci Device Tree in function PciHotPlugRequestNotify for unplug event to fix this issue.

Cc: Feng Ding <feng1.ding@amd.com>
Cc: Jiangang He <jiangang.he@amd.com>
Signed-off-by: Neo Hsueh <Hong-Chih.Hsueh@amd.com>
---
 MdeModulePkg/Bus/Pci/PciBusDxe/PciEnumerator.c | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/MdeModulePkg/Bus/Pci/PciBusDxe/PciEnumerator.c b/MdeModulePkg/Bus/Pci/PciBusDxe/PciEnumerator.c
index 3f8c6e6da7..2b7af60e0a 100644
--- a/MdeModulePkg/Bus/Pci/PciBusDxe/PciEnumerator.c
+++ b/MdeModulePkg/Bus/Pci/PciBusDxe/PciEnumerator.c
@@ -2103,6 +2103,8 @@ PciHotPlugRequestNotify (
       }
     }
 
+    DestroyPciDeviceTree (Bridge);
+
     //
     // End for
     //
-- 
2.40.0.windows.1

